/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - September 24, 2002.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2002
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
// this extends mozilla's default Mail context menu
////////////////////////////////////////////////////////////////////////////////
var multiviewsContextMenu = {

  initItems : function () {
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
    var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
    var browserWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");
    if (!browserWindow)
      gContextMenu.showItem("context-maillinkintab", false);
    else {
      gContextMenu.showItem("context-maillinkintab", gContextMenu.onSaveableLink || 
                            (gContextMenu.inDirList && gContextMenu.onLink));
      var menuItem = document.getElementById("context-maillinkintab");
      if (multiviewsContextMenu.openInNewTab())
        menuItem.setAttribute("label", "Open Link in New Tab");
      else
        menuItem.setAttribute("label", "Open Link in Tab");
    }
  },

  openInNewTab : function () {
    var pref = gContextMenu.getService('@mozilla.org/preferences-service;1', 'nsIPrefBranch');
    var inNewTab = false;
      try {
        inNewTab = pref.getBoolPref("multizilla.newtabfor.mailnews");
      } catch(ex) {
      }
    return inNewTab;
  },

  openMailLinkInTab : function (aID) {
    if (aID == null)
      window.open(gContextMenu.linkURL());
    else 
      loadURLInSelectedWindowAsTab(aID, gContextMenu.linkURL(), 
                                   multiviewsContextMenu.openInNewTab());
  },

  openMailLinkInFirstWindow : function () {
    loadURIinFirstWindow(gContextMenu.linkURL());
  },

  addContextMenuItemListeners : function (aEvent) {
    var mailContextPopup = document.getElementById("messagePaneContext");
    if (mailContextPopup)
      mailContextPopup.addEventListener("popupshowing", multiviewsContextMenu.initItems, false);
  }
};

window.addEventListener("load", multiviewsContextMenu.addContextMenuItemListeners, false);
////////////////////////////////////////////////////////////////////////////////
// this hides all 'non browser' windows
////////////////////////////////////////////////////////////////////////////////
function loadURIinFirstWindow(aURL) 
{
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  var browserWindow = windowManagerInterface.getMostRecentWindow("navigator:browser");
  if (!browserWindow)
    window.open(aURL)
  else { 
    var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].
                                   getService(nsIWindowDataSource);
    for (i = 0; i < 500; i++) {
      var win = windowManager.getWindowForResource("window-"+i);
      if (win) {
        if (win.gBrowser) {
          var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
          if (multiviewsContextMenu.openInNewTab()) {
            var aTab = win.gBrowser.addTab(aURL);
            if (!loadInBackground)
              win.gBrowser.selectedTab = aTab;
          }
          else win.loadURI(aURL);
          break;
        }
      }
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this hides all 'non browser' windows
////////////////////////////////////////////////////////////////////////////////
function initMailWindowSelectorMenu() 
{
  var item = document.getElementById("MailWindowSelectorSeparator");
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].
                                 getService(nsIWindowDataSource);

  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManager.getWindowForResource(url);
    if (win) {
      if (!win.getBrowser || win == window)
        item.setAttribute("hidden", "true");
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
// this function opens aURL (link) in the selected aID (window) and respects 
// the 'New Tab For Messenger' and 'Load In BackGround' pref settings.
////////////////////////////////////////////////////////////////////////////////
function loadURLInSelectedWindowAsTab(aID, aURL, aNewTab)
{
  var item = document.getElementById("MailWindowSelectorSeparator");
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].
                                 getService(nsIWindowDataSource);

  while ((item = item.nextSibling)) {
	var id = item.getAttribute('id');
    if (id == aID) {
      var win = windowManager.getWindowForResource(id);
      var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
      if (aNewTab) {
        var aTab = win.gBrowser.addTab(aURL);
        if (!loadInBackground)
          win.gBrowser.selectedTab = aTab;
      }
      else win.loadURI(aURL);
    }
  }
}